function [W,Sigma,abmean] = mblrakbias( X , T , teX , teY , Parentwithroot , Childrenwithroot , aprior , bprior, w0 , sigma0 );

    [D,N] = size( X );
    [K,N] = size( T );

    iterations = 335;
    W = zeros(K,D);
    Sigma = {};

    leaf = find( sum( Childrenwithroot , 2 ) == 0 );
    nonleaf = find( sum( Childrenwithroot , 2 ) > 0 );
    alpha0 = zeros(1,N);
    alpha = zeros(K,N);
    Xt = X';
    xi = ones(K,N) * .1;
    C = {};
    ind = {};
    %mem = [2,3,4,5,6,7,8,9,10,11,12,13,1,1,2,22,8,23,24,17,25,3,4,26,7,5,6,9,10,27,11,12,13,14,15,16,28,21,18,19,20,1]; 

    biasp = 1e-2;

    mem = 1:K;
    isigma0 = inv( sigma0 );
    NN = 1;
    bprior = bprior * NN;
    aposterior_bias = ones(K,1);
    aposterior = ones(K,1);
    bposterior = ones(K,1);
    abmean = aprior ./ bprior;

    for m = 1:length(mem)
        y = mem(m);
        Sigma{y} = eye(D);
        C{y} = find( Childrenwithroot(y,:) > 0 );
    end

    for m = 1:length(mem)
        y = mem(m);
        p = Parentwithroot(y);
        if p ~= 0
            ind{p} = find( T(p,:) > 0 );
        end
    end


    for iter = 1:iterations

        fprintf(1,'Iteration %d\n',iter);

        Cl = length(C{1});

        Sigma{1} = inv( isigma0 + diag(repmat(sum(abmean(C{1})),1,D)) );

        W(1,:) = ( w0*isigma0 + sum( W(C{1},:) .* [repmat(biasp,Cl,1),repmat(abmean(C{1}),1,D-1)] )  ) * Sigma{1};

        for i = 1:length(C{1})
            c = C{1}(i);

            sumC = diag(Sigma{c})' + diag(Sigma{1})' + (W(1,:) -W(c,:)).^2;

            sumC = sumC(2:end);

            aposterior(c) = aprior(c) + (D-1)/2;

            bposterior(c) = bprior(c) + 1/2*sum(sumC);

            abmean(c) = aposterior(c) ./ bposterior(c);
        end


        for m = 1:length(mem)

            y = mem(m);

            if mod(y,100) == 0
                fprintf(1,' y = %d\n',y);
            end
            p = Parentwithroot(y);

            if p == 0
                continue;
            end

            isleaf = sum( leaf == y );

            if isleaf > 0

                Cl = length(C{y});

                lxiy = lambda(xi(y,:)); % 1xN
                
                alp = alpha0;

                A = 2 * bsxfun(@times,X,lxiy)*Xt; % PxP

                b = ( T(y,:)- .5 + 2* ( alp .* lxiy ) ) * Xt;  % 1xP

                current_cov = [biasp,repmat(abmean(y),1,D-1)];

                Sigma{y} = inv( A +  diag(current_cov));

                W(y,:) = ( b + W(p,:) .* current_cov ) * Sigma{y};

            else

                Cl = length(C{y});

                current_cov = [biasp,repmat(abmean(y),1,D-1)];

                children_cov = [repmat(biasp,Cl,1),repmat(abmean(C{y}),1,D-1)];

                W(y,:) = ( W(p,:) .* current_cov + sum( W(C{y},:).*children_cov ) ) ./ (current_cov + sum(children_cov) );
            end


            for i = 1:length(C{y})
                c = C{y}(i);

                sumC = diag(Sigma{c})' + diag(Sigma{y})' + (W(y,:) -W(c,:)).^2;

                sumC = sumC(2:end);

                aposterior(c) = aprior(c) + (D-1)/2;

                bposterior(c) = bprior(c) + 1/2*sum(sumC);

                abmean(c) = aposterior(c) ./ bposterior(c);
            end

        end

        sc = W*X;

        for m = 1:length(mem)

            y = mem(m);

            p = Parentwithroot(y);

            isleaf = sum( leaf == y );

            if p == 0
                continue;
            end

            if isleaf > 0
                alp = alpha0;

                xi_square = sum( bsxfun(@times,Xt*Sigma{y},Xt) , 2 )' + ( sc(y,:) - alp ) .^ 2;

                xi(y,:) = sqrt( xi_square );
            else 
                alp = alpha(p,:);
            end
        end


        lxi = lambda( xi );

        sl = sc .* lxi;

        alpha0 = ( .5 * ((length(leaf))/2-1) + sum( sl(leaf,:) , 1 ) ) ./  sum( lxi(leaf,:) , 1 ); % 1xN


        [d,pred] = max(W(leaf,:)*teX);

        [d,truth] = max(teY(leaf,:));

        [a,b] = metrics( pred , truth );

        [d1,pred1] = max(W(leaf,:)*X);

        [d1,truth1] = max(T(leaf,:));

        [a1,b1] = metrics( pred1 , truth1 );

        fprintf(1,' Micro-F1 %f Macro-F1 %f\n', a , b );

        fprintf(1,' Micro-F1 %f Macro-F1 %f\n', a1 , b1 );

    end

end


function [ret] = lambda( xi ) 
    ret = tanh(xi/2) ./ (4*xi);
end
