function [acc,maf1,classf1] = metrics( pred , truth )

	tables = zeros(max(truth),4); % tables(i,:) = [ tp , fp , fn ]

	for i = 1:length(pred)
		p = pred(i);
		t = truth(i);
		if p == t
			tables(p,1) = tables(p,1) + 1;
		else
			tables(p,2) = tables(p,2) + 1;
			tables(t,3) = tables(t,3) + 1;
		end
	end

	classf1 = ones( max(truth) , 1 ) * -1;

	for i = 1:size(tables,1)
		tp = tables(i,1);
		fp = tables(i,2);
		fn = tables(i,3);
		if tp + fp + fn > 0 
			prec = tp/(tp+fp);
			rec = tp/(tp+fn);
			f = 2*prec*rec/(prec+rec);
			if isnan(f)
				f = 0;
			end
			classf1(i,:) = f;
        	end
	end

	maf1 = sum( classf1( classf1 > 0 ) ) / sum( classf1 >= -0 );
	acc = sum( pred == truth ) / length( truth );
end